package jrummikub;

import java.util.HashMap;
import java.util.Map;

import javax.swing.UIManager;

import jrummikub.model.Position;
import jrummikub.model.Stone;
import jrummikub.model.StoneColor;
import jrummikub.util.IListener;
import jrummikub.view.IView;

public class JRummikub {

  /**
   * @param args
   */
  public static void main(String[] args) {
    String nativeLF = UIManager.getSystemLookAndFeelClassName();

    try {
      UIManager.setLookAndFeel(nativeLF);
    } catch (Exception e) {
    }
    
    IView view = new jrummikub.view.impl.View();
    
    view.getPlayerPanel().setCurrentPlayerName("Player 1");
    view.getPlayerPanel().setTimeLeft(42);
    view.getTable().setLeftPlayerName("Player 2");
    view.getTable().setTopPlayerName("Player 3");
    view.getTable().setRightPlayerName("Player 4");
    
    view.getPlayerPanel().getSortByNumberEvent().add(new IListener() {
      @Override
      public void fire() {
        System.out.println("'Sort by number' fired");
      }});
    view.getPlayerPanel().getSortByColorEvent().add(new IListener() {
      @Override
      public void fire() {
        System.out.println("'Sort by color' fired");
      }});
    view.getPlayerPanel().getEndTurnEvent().add(new IListener() {
      @Override
      public void fire() {
        System.out.println("'End turn' fired");
      }});
    
    Map<Stone, Position> stones = new HashMap<Stone, Position>();
    stones.put(new Stone(1, StoneColor.ORANGE, false), new Position(0, 0));
    stones.put(new Stone(1, StoneColor.BLUE, false), new Position(1, 0));
    stones.put(new Stone(1, StoneColor.RED, false), new Position(0.5f, 1));

    view.getPlayerPanel().getBoard().setStones(stones);

    
  }

}
